import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopDealerCapital, ShopDealerCapitalParam } from './model';

/**
 * 分页查询分销商资金明细表
 */
export async function pageShopDealerCapital(params: ShopDealerCapitalParam) {
  const res = await request.get<ApiResult<PageResult<ShopDealerCapital>>>(
    '/shop/shop-dealer-capital/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分销商资金明细表列表
 */
export async function listShopDealerCapital(params?: ShopDealerCapitalParam) {
  const res = await request.get<ApiResult<ShopDealerCapital[]>>(
    '/shop/shop-dealer-capital',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分销商资金明细表
 */
export async function addShopDealerCapital(data: ShopDealerCapital) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-dealer-capital',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分销商资金明细表
 */
export async function updateShopDealerCapital(data: ShopDealerCapital) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-dealer-capital',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分销商资金明细表
 */
export async function removeShopDealerCapital(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/shop/shop-dealer-capital/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分销商资金明细表
 */
export async function removeBatchShopDealerCapital(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    '/shop/shop-dealer-capital/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分销商资金明细表
 */
export async function getShopDealerCapital(id: number) {
  const res = await request.get<ApiResult<ShopDealerCapital>>(
    '/shop/shop-dealer-capital/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
